TYPO3.Flow - Bug # 49624

Status: Resolved Priority: Must have
Author: Adrian Foder Category: Validation
Created: 2013-07-03 Assigned To: Bastian Waidelich
Updated: 2014-08-27 Due date:

PHP Version:

Has patch: No

Complexity:

Affected Flow version: Flow 2.0.0

Subject: Domain Model validators are executed twice

Description

when having, for example, a

/**

* @param SampleDto $sampleDto {fq class name abridged}
*/

public function sampleAction(SampleDto $sampleDto);

and an appropriate Validator for that model placed in Domain\Model\Validator\SampleDtoValidator (i.e. a Domain Model Validator in
the sense of [1]), the validation for it is fired twice on action invocation.

The argument's validator stack looks like the following then:

ConjunctionValidator:
SampleDtoValidator
ConjunctionValidator

GenericObjectValidator
SampleDtoValidator

as you can see, the SampleDtoValidator is there twice, that's why it's executed twice.

If, however, the Validator is not a Domain Model Validator, means, it's not placed in Domain\Model\Validator; and annotated manually
like

[
* @param SampleDto $sampleDto {fq class name abridged}

* @Flow\Validate("$sampleDto", type="Acme\Foobar\Somewhere\SampleDtoValidator")
*/

public function sampleAction(SampleDto $sampleDto);

...it's validated correctly only once.
The validator stack then looks like

ConjunctionValidator:
SampleDtoValidator
ConjunctionValidator
GenericObjectValidator

as you can see, the "inner" conjunction validator only has a GenericObjectValidator now.

[#] http://docs.typo3.org/flow/TYPO3FlowDocumentation/TheDefinitiveGuide/Partlll/Validation.html#validating-domain-models

Related issues:
related to Core - Bug # 52607: Domain Model validators are executed twice

Resolved 2013-10-08

Associated revisions

Revision b1633ad8 - 2014-08-25 15:11 - Helmut Hummel

[BUGFIX] Add domain model validators only once

If a domain model validator is present and a controller action accepts
this domain model as argument, the validator is added twice to the

validation tree.

It is added in ValidatorResolver::buildMethodArgumentsValidatorConjunctions()
and in ValidatorResolver::addCustomValidators() which is called from
ValidatorResolver::getBaseValidatorConjunction()

Both methods are called when building the validation tree in
ActionController::initializeActionMethodValidators()

Resolves: #49624
Releases: master, 2.1, 2.0
Change-Id: 11f8902d09f468177d580a7a3d949242cce78313e

Revision 6b38d1f7 - 2014-08-27 18:01 - Helmut Hummel

[BUGFIX] Add domain model validators only once

If a domain model validator is present and a controller action accepts

this domain model as argument, the validator is added twice to the

validation tree.

It is added in ValidatorResolver::buildMethodArgumentsValidatorConjunctions()
and in ValidatorResolver::addCustomValidators() which is called from

ValidatorResolver::getBaseValidatorConjunction()

Both methods are called when building the validation tree in
ActionController::initializeActionMethodValidators()

Resolves: #49624

Releases: master, 2.2, 2.1
Change-Id: 11f8902d09f468177d580a7a3d949242cce78313e
http://docs.typo3.org/flow/TYPO3FlowDocumentation/TheDefinitiveGuide/PartIII/Validation.html#validating-domain-models

Revision 296¢fc95 - 2014-08-27 18:01 - Helmut Hummel

[BUGFIX] Add domain model validators only once

If a domain model validator is present and a controller action accepts
this domain model as argument, the validator is added twice to the

validation tree.

It is added in ValidatorResolver::buildMethodArgumentsValidatorConjunctions()
and in ValidatorResolver::addCustomValidators() which is called from

ValidatorResolver::getBaseValidatorConjunction()

Both methods are called when building the validation tree in
ActionController::initializeActionMethodValidators()

Resolves: #49624

Releases: master, 2.2, 2.1
Change-Id: 11f8902d09f468177d580a7a3d949242cce78313e

History

#1 - 2013-09-06 18:05 - Karsten Dambekalns
- Category set to Validation

#2 - 2013-09-25 11:55 - Bastian Waidelich
- Status changed from New to Accepted

- Assigned To set to Bastian Waidelich
- Affected Flow version changed from Git master to Flow 2.0.0

This might be related to #50585

#3 - 2013-09-30 19:27 - Helmut Hummel

Bastian Waidelich wrote:

This might be related to #50585

| think that is something different.

The issue in this case is, that ValidatorResolver->buildMethodArgumentsValidatorConjunctions()

adds a domain model validator if present and ValidatorResolver->buildBaseValidatorConjunction()

calls ValidatorResolver->addCustomValidators()

which also adds a domain model validator if the class is found.

| suggest to remove the according code from buildMethodArgumentsValidatorConjunctions

#4 - 2013-09-30 19:34 - Gerrit Code Review
- Status changed from Accepted to Under Review
Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24174

#5 - 2013-10-01 09:36 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/24174

#6 - 2013-10-01 16:34 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.

It is available at https://review.typo3.0rg/24174

#7 - 2013-10-07 12:50 - Markus Klein

Also an issue in TYPO3 CMS Extbase!!

#8 - 2014-02-24 11:44 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at https://review.typo3.org/24174

#9 - 2014-02-24 11:46 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at https://review.typo3.0rg/24174

#10 - 2014-08-25 15:11 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.Flow has been pushed to the review server.

It is available at http://review.typo3.org/24174

#11 - 2014-08-27 18:01 - Gerrit Code Review

Patch set 1 for branch 2.2 of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at http://review.typo3.0org/32437

#12 - 2014-08-27 18:01 - Gerrit Code Review

Patch set 1 for branch 2.1 of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at http://review.typo3.org/32438

#13 - 2014-08-27 18:30 - Helmut Hummel
- Status changed from Under Review to Resolved

- % Done changed from 0 to 100

Applied in changeset commit:b1633ad8af5b19c63a1fc4c815b6f079ba27485d.

2015-08-04 5/5



